(* Experimenting with booleans in CL *)

letrec sum = \xs. case xs of
                       <1>      -> 0;
                       <2> x xr -> x + sum xr
                  end; 
       twenty = pack{2, 5, pack{2, 8, pack{2, 7, pack{1}}}};
       (* Booleans may be bound to variables: *)
       t = (sum twenty = 20);
       (* Booleans may be returned by functions: *)
       odd = \x. x % 2 = 1;
       (* Short-circuit evaluation: *)       
       two = if t & odd 7 | (1 / 0 > 10) then 2 else 3;
       numbers = pack{2, two, pack {1}}
in numbers
